# Copyright 2022-2024 Rene Widera, Klaus Steiniger
#
# This file is part of PIConGPU.
#
# PIConGPU is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# PIConGPU is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with PIConGPU.
# If not, see <http://www.gnu.org/licenses/>.
#

##
## This configuration file is used by PIConGPU's TBG tool to create a
## batch script for PIConGPU runs. For a detailed description of PIConGPU
## configuration files including all available variables, see
##
##                 docs/TBG_macros.cfg.
##


#################################
## Section: Required Variables ##
#################################

TBG_wallTime="0:30:00"

TBG_devices_x=1
TBG_devices_y=1
TBG_devices_z=1

TBG_gridSize="192 192 192"
TBG_steps="1000"

TBG_periodic="--periodic 1 1 1"


#################################
## Section: Optional Variables ##
#################################

# file I/O with openPMD-HDF5
TBG_openPMD="--openPMD.period 100   \
             --openPMD.file simData \
             --openPMD.source 'E,B,e_all_chargeDensity' \
             --openPMD.ext bp"

TBG_macroCount="--e_macroParticlesCount.period 100"
TBG_sumEnergy="--fields_energy.period 10 --e_energy.period 10 --e_energy.filter all"
TBG_e_histogram="--e_energyHistogram.period 10 --e_energyHistogram.binCount 512     \
                 --e_energyHistogram.minEnergy 0 --e_energyHistogram.maxEnergy 51000 \
                 --e_energyHistogram.filter all"

TBG_plugins="!TBG_openPMD   \
             !TBG_macroCount \
             !TBG_sumEnergy \
             !TBG_e_histogram"


#################################
## Section: Program Parameters ##
#################################

TBG_deviceDist="!TBG_devices_x !TBG_devices_y !TBG_devices_z"

TBG_programParams="-d !TBG_deviceDist \
                   -g !TBG_gridSize   \
                   -s !TBG_steps      \
                   !TBG_periodic      \
                   !TBG_plugins       \
                   --versionOnce"

# TOTAL number of devices
TBG_tasks="$(( TBG_devices_x * TBG_devices_y * TBG_devices_z ))"

"$TBG_cfgPath"/submitAction.sh
